function UnityProgress (dom) {
	this.progress = 0.0;
	this.message = "Loading... Please Wait";
	this.dom = dom;
        
        this.increment = 0.0;
        this.fakeprogress = 0;
        this.percent = 0;
        
	var parent = dom.parentNode;
        var that = this;
         
	var background = document.createElement("div");
	background.style.background = "#4D4D4D";
        background.style.backgroundImage = "url(TemplateData/preloader-cinema.jpg)";
        background.style.backgroundPosition = "center";
        background.style.backgroundSize = "cover";
	background.style.position = "absolute";
       
	parent.appendChild(background);
	this.background = background;

	var logoImage = document.createElement("img");
	logoImage.src = "TemplateData/loading.gif"; 
	logoImage.style.position = "absolute";
	parent.appendChild(logoImage);
	this.logoImage = logoImage;

	var progressFrame = document.createElement("img");
	progressFrame.src = "TemplateData/loadingbar.png"; 
	progressFrame.style.position = "absolute";
	parent.appendChild(progressFrame);
	this.progressFrame = progressFrame;

	var progressBar = document.createElement("img");
	progressBar.src = "TemplateData/fullbar.png"; 
	progressBar.style.position = "absolute";
	parent.appendChild(progressBar);
	this.progressBar = progressBar;

	var messageArea = document.createElement("p");
        messageArea.style.fontSize = "16px";
        messageArea.style.fontWeight = "bold";
        messageArea.style.color = "#FFF";
        messageArea.style.marginTop = "30px";
	messageArea.style.position = "absolute";
	parent.appendChild(messageArea);
	this.messageArea = messageArea;


	this.SetProgress = function (progress) { 
		if (this.progress < progress)
			this.progress = progress; 
		this.Update();
	}

	this.SetMessage = function (message) { 
		this.message = message; 
		this.Update();
	}

	this.Clear = function() {
		this.background.style.display = "none";
		this.logoImage.style.display = "none";
		this.progressFrame.style.display = "none";
		this.progressBar.style.display = "none";
                this.messageArea.style.display = "none";
                
                clearInterval(this.timer);
	}

	this.Update = function() {
		this.background.style.top = this.dom.offsetTop + 'px';
		this.background.style.left = this.dom.offsetLeft + 'px';
		this.background.style.width = this.dom.offsetWidth + 'px';
		this.background.style.height = this.dom.offsetHeight + 'px';

		var logoImg = new Image();
		logoImg.src = this.logoImage.src;
		var progressFrameImg = new Image();
		progressFrameImg.src = this.progressFrame.src;
                
               if(this.fakeprogress > 0.05 && this.fakeprogress<=this.progress){
                   this.increment = 0.0;
               }
                
                this.fakeprogress = this.progress + this.increment;
                if(this.fakeprogress > 1) this.fakeprogress = 1;
                
                
                this.percent = Math.ceil(this.fakeprogress * 100);
                
                
                
		this.logoImage.style.top = this.dom.offsetTop + (this.dom.offsetHeight * 0.5 - logoImg.height * 0.5) + 'px';
		this.logoImage.style.left = this.dom.offsetLeft + (this.dom.offsetWidth * 0.5 - logoImg.width * 0.5) + 'px';
		this.logoImage.style.width = logoImg.width+'px';
		this.logoImage.style.height = logoImg.height+'px';

		this.progressFrame.style.top = this.dom.offsetTop + (this.dom.offsetHeight * 0.5 + logoImg.height * 0.5 + 10) + 'px';
		this.progressFrame.style.left = this.dom.offsetLeft + (this.dom.offsetWidth * 0.5 - progressFrameImg.width * 0.5) + 'px';
		this.progressFrame.width = progressFrameImg.width;
		this.progressFrame.height = progressFrameImg.height;

		this.progressBar.style.top = this.progressFrame.style.top;
		this.progressBar.style.left = this.progressFrame.style.left;
		this.progressBar.width = progressFrameImg.width * this.fakeprogress;
		this.progressBar.height = progressFrameImg.height;

		this.messageArea.style.top = this.progressFrame.style.top;
		this.messageArea.style.left = 0;
		this.messageArea.style.width = '100%';
		this.messageArea.style.textAlign = 'center';
                
		this.messageArea.innerHTML = "Loading... "+ this.percent + " %";
	}
        
        this.clock = function(){
           that.increment += 0.01;
           that.Update();
        }
       
        this.timer = setInterval(this.clock,3000);
	this.Update();
        
        
       
}